
#include "SimpleTypeSystem.h"

#include <stdlib.h>
#include <string.h>

char * s_get_version_string () {
  char * ret_val = malloc ( sizeof(char) * 32);
  sprintf (ret_val, "Version: %d.%d.%d ", s_get_version_major (),
                                           s_get_version_minor (),
                                           s_get_version_patch ());
  return ret_val;
}

int s_get_version_major () {
  return SIMPLE_TYPE_SYSTEM_VERSION_MAJOR;
}

int s_get_version_minor () {
  return SIMPLE_TYPE_SYSTEM_VERSION_MINOR;
}

int s_get_version_patch () {
  return SIMPLE_TYPE_SYSTEM_VERSION_PATCH;
}

char * s_string_new (const char * s) {
  char * ret_val = malloc (strlen (s) + 1);
  strcpy (ret_val, s);
  return ret_val;
}

char * s_string_new_with_lenghth (const char * s, size_t len) {
  char * ret_val = malloc (len);
  strncpy (ret_val, s, len);
  return ret_val;
}
